Attribute VB_Name = "StatMod"
Option Explicit            ' Requires programmer to declare all variables
' Print form Snapshot variables and Sub
Public Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
Public Const VK_MENU = &H12
Public Const VK_SNAPSHOT = &H2C
Public Const KEYEVENTF_KEYUP = &H2
' Public Arguments available anywhere
Public strOutDir As String        ' Input/Output File Directory
Public strErrFile As String       ' Error output file
Public StrStationFile As String   ' Input Station Number File Name
Public StrPRDataFile As String    ' Input Partial Record Station Data File Name
Public StrOutputFile As String    ' Program output file
Public strMMOutput As String      ' output of program
Public lngnumsta As Long          ' number of reference stations
Public lngNumPRQs As Long         ' number of partial record values
Public strPRStation As String     ' Partial record station number
Public strPRSTAName As String     ' Partial record station name
Public strInStations() As String  ' Input long-term station numbers
Public PRDates() As Date          ' Partial-Record Dates
Public dPRQ() As Double           ' Partial record flow (Q)
Public strRQC() As String         ' Partial record flow (Q) code
Public dPPRQ() As Double          ' paired values for paritial record and lt flow
Public dLTQ() As Double           ' Long-term flow (Q)
Public lngZed As Long             ' number of flows that are zero
Public dtBeginDate As Date        ' User Specified Beginning date read from long-term record
Public dtEndDate As Date          ' User Specified End Date from long-term record
Public lngNDays As Long           ' Calculated days in long-term record
Public dXiAvg2() As Double        ' Long-term station average for nonconcurrent for use with MOVE.3
Public dSx2() As Double           ' Long-term station standard deviation for nonconcurrent for use with MOVE.3
Public lngNumX2() As Long         ' Number of nonconcurrent flows
Public mv1Slope() As Double       ' MOVE.1 slope per lt station
Public mv1Int() As Double         ' MOVE.1 intercept per lt station
Public mv3Slope() As Double       ' MOVE.3 slope per lt station
Public mv3Int() As Double         ' MOVE.3 intercept per lt station
Public dMv1BCF() As Double        ' MOVE.1 BCF
Public dMv3BCF() As Double        ' MOVE.3 BCF
Public dMv1MSE() As Double        ' MOVE.1 intercept per lt station
Public dMv3MSE() As Double        ' Mean Square Error per lt station
Public lngNumZero() As Long       ' Number of zero flows per lt station
Public dCorr() As Double          ' Long-term station correlation for common measurements with short term
Public lngSelectedSta As Long     ' Currently selected Long-term station
Public intGraph As Integer        ' The type of graph selected on MoveFrm02 to be plotted on MoveFrm03
Public dtMyDate() As Date         ' Date of partial/short-term record measurement
Public intPRDateTie As Integer    ' Date-tie flag
Public dMax() As Double           ' Long-term station max for common measurements with short term
Public dMin() As Double           ' Long-term station min for common measurements with short term
Public strQCd() As String         ' Long-term station Q code
Public intDVStation As Integer    ' 1A NWIS Web Station No. column
Public intDVDate As Integer       ' 1B. NWIS Web Date column
Public intDVQ As Integer          ' 1C. NWIS Web Mean Daily Flow column
Public intDVQCom As Integer       ' 1D. NWIS Web Mean Daily Flow Code column
Public intRDBStation As Integer   ' 2A. NWIS Web Measurement Station No. column
Public intRDBQCom As Integer      ' 2B. NWIS Web Measurement No.  column (meas #)
Public intRDBDate As Integer      ' 2C. NWIS Web Measurement Date column
Public intRDBQ  As Integer        ' 2D. NWIS Web Measurement Flow column
Public intf01AP  As Integer    ' 3A. FORTRAN01 ADAPS 9207 Measurements No. position
Public intf01AW  As Integer    ' 3A. FORTRAN01 ADAPS 9207 Measurements No. width
Public intf01BP  As Integer    ' 3B. FORTRAN01 ADAPS 9207 Measurements Date position
Public intf01BW  As Integer    ' 3B. FORTRAN01 ADAPS 9207 Measurements Date width
Public intf01CP  As Integer    ' 3C. FORTRAN01 ADAPS 9207 Measurements Flow position
Public intf01CW  As Integer    ' 3C. FORTRAN01 ADAPS 9207 Measurements Flow width
Public intf02AP  As Integer    ' 4A. FORTRAN02 ADAPS Full Measurements No. position
Public intf02AW  As Integer    ' 4A. FORTRAN02 ADAPS Full Measurements No. width
Public intf02BP  As Integer    ' 4B. FORTRAN02 ADAPS Full Measurements Date Measurements Date position
Public intf02BW  As Integer    ' 4B. FORTRAN02 ADAPS Full Measurements DateMeasurements Date width
Public intf02CP  As Integer    ' 4C. FORTRAN02 ADAPS Full Measurements Flow position
Public intf02CW  As Integer    ' 4C. FORTRAN02 ADAPS Full Measurements Flow width
Public lngGraphPairs As Long   ' Pairs of graph values
Public lngQdates() As Long     ' Long Integer Array for dates with flow values
Public bUserPrompts As Boolean ' User prompt variable True = user promts on
Public bnMOVE3() As Boolean    ' boolean variable true if we have independent MOVE.3 estimate false if too few nonconcurrent measurements


Sub ChkSta(strStaNum As String, iEc As Integer, intmode As Integer)
'
' Purpose:
' To read and check 8-12 digit station number from text1.txt
' History:
' Version 1.0 May 2004 by G.E. Granato
' strStaNum              ' input NWIS station number as string
' iec                    ' output error code 0 = everything ok
' intmode                ' mode 1= interactive 2= batch
' Arguments
Dim ci As Integer                 ' check loop integer 1
Dim cj As Integer                 ' check loop Integer
Dim cnum As Integer               ' check number sum
Dim n1 As Integer                 ' Integer test variable
Dim n2 As Integer                 ' Integer count variable
Dim ck2 As Variant                ' variant
Dim StrErrMsg As String           ' Error string
On Error GoTo Err_ChkSta:
iEc = 0
' trim leading or trailing spaces
   strStaNum = Trim(strStaNum)
'  trim leading or trailing tab
  If Left(strStaNum, 1) = Chr(9) Then
   n2 = Len(strStaNum)
   strStaNum = Right(strStaNum, (n2 - 1))
  End If
  If Right(strStaNum, 1) = Chr(9) Then
   n2 = Len(strStaNum)
   strStaNum = Left(strStaNum, (n2 - 1))
  End If
' retrim leading or trailing spaces
   strStaNum = Trim(strStaNum)
' check for proper length ' 8-12 characters
10 n2 = Len(strStaNum)
If (n2 >= 8) And (n2 <= 12) Then
 'check each character to ensure it is a number
  cnum = 0
  For ci = 1 To n2
   n1 = Mid(strStaNum, ci, 1)
   For cj = 0 To 9
    If n1 = cj Then
     cnum = cnum + 1
     GoTo 15
    End If
   Next cj
15  Next ci
  If cnum = n2 Then
   iEc = 0
   Exit Sub
  Else
   iEc = 2 'nonnumeric response
   Exit Sub
  End If
 ' if less than 8 declare error 1 and exit
 ElseIf n2 < 8 Then
  iEc = 1 'error station number too short
  Exit Sub
 'if greater than 12 try to trim left or right
 ElseIf n2 > 12 Then
  iEc = 3 'error station number too long
 Exit Sub
 End If
Err_ChkSta:
 If Err.Number = 13 Then
  If intmode = 1 Then
   StrErrMsg = " Error character number: " & ci & " is not an integer please correct"
   MsgBox StrErrMsg
  End If
 Else
  If intmode = 1 Then
  MsgBox "Other Error"
  End If
 End If
 iEc = 2
 Exit Sub
End Sub


Sub ChkDate(vDate As Variant, iEc As Integer, intmode As Integer)
'
' Purpose:
' To read and check date values
' History:
' Version 1.0 Dec. 2005 by G.E. Granato
' strStaNum              ' input date
' iec                    ' output error code 0 = everything ok
' intmode                ' mode 1= interactive 2= batch
' Arguments
  Dim dtDate As Date
  On Error GoTo Date_Err:
  iEc = 0
  dtDate = vDate
  Exit Sub
Date_Err:
  iEc = 1
End Sub



Sub ChkDFiles(strOutDir As String, strStaNum As String, intimode As Integer, intErrCode As Integer)
'
' Purpose:
' To check that {header file} and data file for station number
' exist and have some data
' History:
' Version 1.0 May 2004 by G.E. Granato
' strStaNum           'input NWIS station number as string
' IntErrCode          'output error code 0 = everything ok
'                     ' 1= no header file 2 = no data file
'                     ' 3 = both
' intimode            ' mode 1= interactive 2= batch
' Arguments
Dim bnFileExists As Boolean     ' Check variable for file existance
Dim intErrorSum As Integer      ' error code builer
Dim strHeadFile As String       ' header file name
Dim strDatFile As String        ' data file name
Dim StrErrMsg As String             ' Error Message
' Initialize vars on call
intErrorSum = 0
intErrCode = 0
'Check that header file exists and has data
'   strHeadFile = strOutDir & strStaNum & "H.txt"
'   bnFileExists = bnCheckFile(strHeadFile)
'   If bnFileExists = False Then
'    intErrorSum = intErrorSum + 1
'    If intimode = 1 Then
'     StrErrMsg = "Error: Header File: " & Chr(13) & Chr(10) & _
'     strHeadFile & Chr(13) & Chr(10) & _
'     "Does Not Exist."
'     MsgBox StrErrMsg
'    End If
'   Else
   'check if file empty
'    If FileLen(strHeadFile) = 0 Then    'vb6 intrinsic file length function
'     intErrorSum = intErrorSum + 1
'     If intimode = 1 Then
'      StrErrMsg = "Error: Header File: " & Chr(13) & Chr(10) & _
'      strHeadFile & Chr(13) & Chr(10) & _
'      "Has no data."
'      MsgBox StrErrMsg
'     End If
'    End If
'   End If
  'Check that data file exists
   strDatFile = strOutDir & strStaNum & "Q.txt"
   bnFileExists = bnCheckFile(strDatFile)
   If bnFileExists = False Then
    intErrCode = 2                     'no data file
    If intimode = 1 Then
     StrErrMsg = "Error: Data File: " & Chr(13) & Chr(10) & _
     strDatFile & Chr(13) & Chr(10) & _
     "Does Not Exist."
     MsgBox StrErrMsg
    End If
   Else
   'check if file empty
    If FileLen(strDatFile) = 0 Then    'vb6 intrinsic file length function
     intErrCode = 2                     'no data file
     If intimode = 1 Then
      StrErrMsg = "Error: Data File: " & Chr(13) & Chr(10) & _
      strDatFile & Chr(13) & Chr(10) & _
      "Has no data."
      MsgBox StrErrMsg
     End If
    End If
   End If
intErrorSum = intErrorSum + intErrCode
intErrCode = intErrorSum
Exit Sub
End Sub

Sub CkQ(vQc As Variant, intEC As Integer, imode As Integer)
'
' Purpose:
' To read and check flow values
' History:
' Version 1.0 Dec. 2005 by G.E. Granato
' vQc                    ' flow must be numeric and >=0
' intec                   ' output error code 0 = everything ok
' intmode                ' mode 1= interactive 2= batch
' Arguments
  Dim dFlow As Double
  On Error GoTo Date_Err:
  intEC = 0
  dFlow = vQc
  
  If dFlow < 0 Then intEC = 1
  Exit Sub
Date_Err:
  intEC = 1


End Sub

Sub CkVal(vQc As Variant, intEC As Integer, imode As Integer)
'
' Purpose:
' To read and check input values
' History:
' Version 1.0 Dec. 2005 by G.E. Granato
' vQc                    ' flow must be numeric and >=0
' intec                   ' output error code 0 = everything ok
' intmode                ' mode 1= interactive 2= batch
' Arguments
  Dim dFlow As Double
  On Error GoTo Q_Err:
  intEC = 0
  dFlow = vQc

  Exit Sub
Q_Err:
  intEC = 1


End Sub


Sub STATS02(RinQ() As Double, num As Long, avg As Double, var As Double, sdev As Double, skew As Double)
'
' Purpose:
' Takes array RinQ and returns statistics for regression
' utilizes equations in:
' U.S. Interagency Advisory Commitee on Water Data, 1982,
' Guidelines for determining flood flow frequency, Bulletin 17-B
' of the Hydrology Subcommittee: Reston Virginia,
' U.S. Geological Survey Office of Water Data Coordination, 183 p.
'
' History:
' Version 1.0 May 2004 by G.E. Granato
' Subroutine arguments
'
' num    number of values in array
' avg    average of array
' var    variance of array
' sdev   standard deviation of array
' skew   skew coefficient of array
'
' Internal variables
Dim ssum As Double        ' sum of input values or higher moment sum
Dim sVARsum As Double     ' sum for higher moments
Dim sSKWsum As Double     ' product for higher moments
Dim scnt As Double        ' Double count
Dim lngn As Long          ' Max counter for warm-up loop
Dim lngI As Long          ' First for-next index variable
Dim lngK As Long          ' quotient from integer division
ssum = 0#
scnt = CDbl(num) / 1#
' Do first pass to calculate average
For lngI = 1 To num
ssum = ssum + RinQ(lngI)
Next lngI
' Calculate average
avg = ssum / scnt
' initialize for higher moments
var = 0#
sdev = 0#
skew = 0#
ssum = 0#
sVARsum = 0#
sSKWsum = 0#
' second pass to get higher moments
For lngI = 1 To num
 ssum = (RinQ(lngI) - avg)
 sVARsum = sVARsum + (ssum * ssum)
 sSKWsum = sSKWsum + (ssum * ssum * ssum)
Next lngI
' calculate final values
var = sVARsum / (scnt - 1#)
sdev = Sqr(var)
' if var=0 division by zero error
If (var <> 0#) Then
 skew = (scnt * sSKWsum) / ((scnt - 1#) * (scnt - 2#) * (sdev * sdev * sdev))
Else
 skew = -0.000000000191
End If
End Sub

Sub GetSXY(dXI() As Double, dYI() As Double, XMean As Double, YMean As Double, num As Long, dSXY As Double)
'
' Purpose:
' Takes arrays and statistics for X & Y and returns SXY which is used for the correlation coefficient
' utilizes equations in:
' Helsel D.R., and Hirsch, R.M., 2002,
' Statistical methods in water resourcesHydrologic analysis and interpretation:
' Techniques of Water-Resources Investigations of the U.S. Geological Survey, Chap. A3, book 4, 510 p.
' (Chapters 1, 9, and 10)
'
' History:
' Version 1.0 Dec. 2005 by G.E. Granato
'
' Subroutine arguments
'
' num    number of values in array
' dXI    X array
' dYI    Y array
' XMean  Average of X array
' YMean  Average of Y array
' dSXY   sums of x y cross products of arrays
'
' Internal variables
Dim dcnt As Double        ' Double count
Dim lngn As Long          ' Max count variable

dcnt = num / 1#
dSXY = 0#

For lngn = 1 To num
 dSXY = dSXY + ((dXI(lngn) - XMean)) * ((dYI(lngn) - YMean))
Next lngn

End Sub

Public Sub ConvertFortran(iFNo As Integer, sInfile As String, sStaNum As String, sStaNam As String, _
lngRecNo As Long, interr As Integer)
'
'Purpose: Change FORTRAN FORMAT to Tab delimited
'
' History:
' Version 1.0 March 2007 by G.E. Granato
'
' Subroutine arguments
' iFNo     type of fortran file format 01 or 02
' sInfile  input file name
'          and output filename
' sStaNum  input station number
' sStaNam  input station name
' lngRecNo number of records seperate days
' intERR   error code
'
' Arguments
Dim intfile01 As Integer      ' file number
Dim intfile03 As Integer      ' file number
Dim strTMPFile As String      ' new file name
Dim lngI As Long              ' loop variable
Dim strInLine As String       ' read line
Dim strOutLine As String       ' read line
Dim vQ As Variant             ' temporary q
Dim vMyDate As Variant        ' temporary date
Dim vLineNumber As Variant    ' temporary line number
Dim bDate As Boolean          ' check date
Dim bLng As Boolean           ' check long
Dim bSng As Boolean           ' check single

On Error GoTo FORT_ERR:
interr = 0

' Create new 2 column file
strTMPFile = Trim(sInfile) & ".RDB.txt"

intfile01 = FreeFile
Open sInfile For Input As intfile01
intfile03 = FreeFile
Open strTMPFile For Output As intfile03

strOutLine = sStaNum & Chr(9) & sStaNam
Print #intfile03, strOutLine

lngI = 0
Do While EOF(intfile01) = False
 Line Input #intfile01, strInLine   'Read Line
 If iFNo = 1 Then
  vLineNumber = Trim(Mid(strInLine, intf01AP, intf01AW))
  vMyDate = Trim(Mid(strInLine, intf01BP, intf01BW))
  vQ = Trim(Mid(strInLine, intf01CP, intf01CW))
 Else
  vLineNumber = Trim(Mid(strInLine, intf02AP, intf02AW))
  vMyDate = Trim(Mid(strInLine, intf02BP, intf02BW))
  vQ = Trim(Mid(strInLine, intf02CP, intf02CW))
 End If
 ' Check contents
 If Len(vLineNumber) > 0 And Len(vMyDate) > 0 And Len(vQ) > 0 Then
  bDate = AmIDate(vMyDate)
  bLng = AmILong(vLineNumber)
  bSng = AmISingle(vQ)
  
  If bDate = True And bLng = True And bSng = True And vQ > 0# Then
   strOutLine = Format(vMyDate, "YYYY-MM-DD") & Chr(9) & Format(vQ, "#####0.0##") & Chr(9) & vLineNumber
   Print #intfile03, strOutLine
   lngI = lngI + 1
  End If
 End If
Loop

lngRecNo = lngI

If lngRecNo < 3 Then interr = 1

If interr = 0 Then sInfile = strTMPFile

Close intfile01
Close intfile03

Exit Sub

FORT_ERR:
 interr = 1
 Exit Sub
End Sub



Public Function bnCheckFile(strStaFile As String) As Boolean
'
' Purpose:
' To check that file exists for processing or other action
' History:
' Version 1.0 May 2004 by G.E. Granato
' strStaFile is a string that includes the dive, directory and filename
' for the file of interest
'
' Arguments
  If Dir$(strStaFile) <> "" Then  'vb intrinsic file function
   bnCheckFile = True
  Else
   bnCheckFile = False
  End If
End Function

Public Function GEGFormatQ(dqin As Double) As String
'
' Purpose: Takes streamflow and formats sig figs
'
' History:
' Version 1.0 March 2007 by G.E. Granato
'
' Internal variables
Dim strMyQ As String

 ' set Q string
    If dqin < 0.01 Then
     strMyQ = Format(dqin, "0.000E+00")
    ElseIf dqin < 0.1 Then
     strMyQ = Format(dqin, "0.0000")
    ElseIf dqin < 1# Then
     strMyQ = Format(dqin, "0.000")
    ElseIf dqin < 10# Then
     strMyQ = Format(dqin, "#0.00")
    Else
     strMyQ = Format(dqin, "#####0.0")
    End If
    GEGFormatQ = strMyQ

End Function
Public Function AmIDate(vin As Variant) As Boolean
'
' Purpose: take a variant and see if it is a date true or false
'
' History:
' Version 1.0 May 2004 by G.E. Granato
'
' vin input variant
'
Dim Adate As Date

On Error GoTo DateErr:

Adate = CDate(vin)

AmIDate = True

Exit Function
DateErr:

AmIDate = False

End Function

Public Function AmILong(vin As Variant) As Boolean
'
' Purpose: take a variant and see if it is a long integer true or false
'
' History:
' Version 1.0 May 2004 by G.E. Granato
'
' vin input variant
'

Dim Along As Long

On Error GoTo LongErr:

Along = CLng(vin)

AmILong = True

Exit Function
LongErr:

AmILong = False

End Function

Public Function AmISingle(vin As Variant) As Boolean
'
' Purpose: take a variant and see if it is a single true or false
'
' History:
' Version 1.0 May 2004 by G.E. Granato
'
' vin input variant
'
Dim ASingle As Long

On Error GoTo SingleErr:

ASingle = CSng(vin)

AmISingle = True

Exit Function
SingleErr:

AmISingle = False

End Function


Public Function INIVal(vin As Variant, lngLim1 As Long, lnglim2 As Long) As Long
'
' Purpose: take a variant and see if it is a long in the right range
' return the value if ok return an error -1 if not
'
' History:
' Version 1.0 May 2004 by G.E. Granato
'
' vin input variant
' lngLim1 lower limit
' lngLim2 upper limit
'
Dim bIslng As Boolean
Dim lngVal As Long

bIslng = AmILong(vin)


If bIslng = False Then
 INIVal = -1
 Exit Function
End If

lngVal = CLng(vin)

If lngVal < lngLim1 Then
 INIVal = -1
 Exit Function
ElseIf lngVal > lnglim2 Then
 INIVal = -1
 Exit Function
Else
 INIVal = lngVal
End If

End Function


Public Function StringDate(dtStartDate As Date, lngCurrentDay As Long, intFormat As Integer) As String
'
' Purpose: take a start date and number of days afterward return that date as a string
' in a specified format
'
' History:
' Version 1.0 Nov 2007 by G.E. Granato
'
' lngCurrentDay is = 1 + current day with the begining date=0
' vin input variant
' lngLim1 lower limit
' lngLim2 upper limit
'
 Dim strDate As String  ' Date string
 Dim dtToday As Date    ' Today's date based on lngcurrent day
 Dim strDay As String   ' Day string
 Dim strMonth As String ' Month string
 Dim strYear As String  ' Year string
      
On Error GoTo ERR_FNDate:

' Set the current date
  dtToday = dtStartDate + (lngCurrentDay - 1)
  
'Year
  strYear = Year(dtToday)
         
' Month 1 or 2 digit
  If Month(dtToday) < 10 Then
   strMonth = "0" & Month(dtToday)
  Else
   strMonth = Month(dtToday)
  End If
           
' Day 1 or 2 digit
  If Day(dtToday) < 10 Then
   strDay = "0" & Day(dtToday)
  Else
   strDay = Day(dtToday)
  End If
                        
Select Case intFormat
 Case 1 'YYYY-MM-DD
  strDate = strYear & "-" & strMonth & "-" & strDay
 Case 2 'MM/DD/YYYY
  strDate = strMonth & "/" & strDay & "/" & strYear
 Case 3 'MM/DD/YY
  strDate = strMonth & "/" & strDay & "/" & Right(strYear, 2)
End Select
 ' return date
 StringDate = strDate
Exit Function
           
ERR_FNDate:
' if problem return error
 StringDate = "Date Error"
           
End Function

Public Function RoundQ(dInQ As Double) As String
'
' Purpose Round double precision value based on magnitude
'
' History:
' Version 1.0 November 2007 by G.E. Granato
'
' dInQ double precision input flow
'
Dim strTemp As String

On Error GoTo ERR_Round:
If dInQ < 0.1 Then
     strTemp = Format(dInQ, "0.000")
    ElseIf dInQ < 1# Then
     strTemp = Format(dInQ, "0.00")
    ElseIf dInQ < 10# Then
     strTemp = Format(dInQ, "#0.0")
    Else
     strTemp = Format(dInQ, "####0.")
    End If
 RoundQ = strTemp
Exit Function
ERR_Round:
    RoundQ = CStr(dInQ)
End Function

Public Function dEstimateZedQ(intMyZedQ As Integer, dMyZedQ As Double, dMyYesterdayQ As Double) As Double
' purpose substitue a zero flow
'
'
' History:
' Version 1.0 November 2007 by G.E. Granato
'
' intMyZedQ as integer     'type of substitution
' dMyZedQ as double        'value to substitute or multiply
' dMyYesterdayQ as double  'last value for Q
'
Dim dMyEstQ As Double

On Error GoTo ERR_Zed:

If intMyZedQ = 1 Then 'Use zero flow
   dMyEstQ = 0#
ElseIf intMyZedQ = 2 Or intMyZedQ = 3 Then   ' use input value (2 =0.01) 3 = user specified
   dMyEstQ = dMyZedQ
ElseIf intMyZedQ = 4 Then        ' use zed Q as a recession constant
   dMyEstQ = dMyYesterdayQ * dMyZedQ
Else
   dMyEstQ = 0#
End If
  
dEstimateZedQ = dMyEstQ

Exit Function

ERR_Zed:
 dEstimateZedQ = 0#
End Function


